#!/usr/bin/env bash
set -eu

if [ "$(id -u)" != "0" ]; then
  export USER_ID=${USER_ID:-"$(id -u)"}
  export GROUP_ID=${GROUP_ID:-"$(id -g)"}
  export USERNAME=${USERNAME:-unknown}
{% if with_nonroot %}elif [ "$(id -u)" == "0" ] && [ ! -v USER_ID ]; then
  export USER_ID=
  USER_ID="$(id -u nonroot)"
  export GROUP_ID=
  GROUP_ID="$(id -g nonroot)"
  export USERNAME=nonroot
  export HOME=/home/"$USERNAME"{% endif %}
else
  export USER_ID=${USER_ID:-$(id -u)}
  export GROUP_ID=${GROUP_ID:-$(id -g)}
  export USERNAME=${USERNAME:-root}
  export HOME=/home/"$USERNAME"
  [ ! -d "$HOME" ] && mkdir -p "$HOME" && chown "${USER_ID}":"${GROUP_ID}" "$HOME"
fi

if [ "${USER_ID}" -eq 0 ]; then
  export USERNAME=root
  export HOME=/$USERNAME
fi
[ -d "$HOME" ] && cd "$HOME"

if [ "$(id -u)" -eq "0" ] && [ "$(id -u)" != "${USER_ID}" ]; then
  groupadd --gid "$GROUP_ID" --non-unique "$USERNAME" || true
  useradd --shell /bin/bash -u "$USER_ID" -g "$USERNAME" -o -c "" -m "$USERNAME" || true

  exec chroot --userspec "${USER_ID}":"${GROUP_ID}" --skip-chdir / "$@"
else
  exec "$@"
fi
